{% extends "./plantilla.html" %}
{% load static %}
{% block contenido %}
    <div class="container">
        <div class="row">
            <div class="col-md-6">
                <h1 class="text-center blanco-text">Nueva Asignatura</h1>
                <form class="mb-4" action="/guardarAsignatura/" method="post" enctype="multipart/form-data" id="frm_nueva_asig">
                    {% csrf_token %}
                    <div class="mb-3">
                        <label for="idCursoBAFA" class="form-label blanco-text">Curso:</label>
                        <select  name="idCursoBAFA"  id="idCursoBAFA" data-live-search="true" data-live-search-style="startsWith" class="selectpicker"required>
                            <option value="">--Seleccione el Curso--</option>
                            {% for curso in cursos %}
                              <option value="{{curso.idCursoBAFA}}">{{curso.nivelCursoBAFA}}</option>
                            {% endfor %}
                        </select>
                    </div>
                    <div class="mb-3">
                        <label for="nombreAsignaturaBAFA" class="form-label blanco-text">Nombre de la Asignatura:</label>
                        <input type="text" name="nombreAsignaturaBAFA" id="nombreAsignaturaBAFA" value="" class="form-control" placeholder="Ingrese el nombre de la Asignatura:" required>
                    </div>
                    <div class="mb-3">
                        <label for="creditosAsignaturaBAFA" class="form-label blanco-text"><b>Ingrese los Creditos de la Asingaturas:</b></label>
                        <input type="number" name="creditosAsignaturaBAFA" id="creditosAsignaturaBAFA" value="" class="form-control" placeholder="Ingrese los Creditos de la Asingaturas:" required>
                    </div>
                    <div class="mb-3">
                        <label for="fechaInicioAsignaturaBAFA" class="form-label blanco-text">Fecha de Inicio de la Asignatura:</label>
                        <input type="date" name="fechaInicioAsignaturaBAFA" id="fechaInicioAsignaturaBAFA" value="" class="form-control" placeholder="Ingrese la fecha de Inicio de la Asignatura" required>
                    </div>
                    <div class="mb-3">
                        <label for="fechaFinalizacionAsignaturaBAFA" class="form-label blanco-text">Fecha de Finalizacion de la Asignatura:</label>
                        <input type="date" name="fechaFinalizacionAsignaturaBAFA" id="fechaFinalizacionAsignaturaBAFA" value="" class="form-control" placeholder="Ingrese la fecha de Finalizacion de la Asignatura" required>
                    </div>
                    <div class="mb-3">
                        <label for="profesorAsignaturaBAFA" class="form-label blanco-text">Ingrese el Profesor de la Asignatura:</label>
                        <input type="text" name="profesorAsignaturaBAFA" id="profesorAsignaturaBAFA" value="" class="form-control" placeholder="Ingrese el Profesor de la Asignatura:" required>
                    </div>
                    <div class="mb-3">
                        <label for="silaboAsignaturaBAFA" class="form-label blanco-text">Ingrese el silabo de la Asignatura:</label>
                        <input type="file" accept="application/pdf" name="silaboAsignaturaBAFA" id="silaboAsignaturaBAFA" value="" class="form-control" placeholder="Ingrese el silabo de la Asignatura:" required>
                    </div>
                    <div class="mb-3">
                        <label for="metodoEvaluacionBAFA" class="form-label blanco-text">Ingrese el Metodo de la Evaluación:</label>
                        <input type="text" name="metodoEvaluacionBAFA" id="metodoEvaluacionBAFA" value="" class="form-control" placeholder="Ingrese el Metodo de la Evaluación:" required>
                    </div>
                    <div class="mb-3">
                        <label for="recursosDidacticosBAFA" class="form-label blanco-text">Ingrese los Recursos de la Asingaturas:</label>
                        <textarea name="recursosDidacticosBAFA" id="recursosDidacticosBAFA" cols="3" class="form-control" placeholder="Ingrese los Recursos de la Asingaturas:" required></textarea>
                    </div>
                    <div class="text-center">
                        <button type="submit" name="button" class="btn btn-primary">Guardar</button>
                        <button type="reset" name="button" class="btn btn-danger">Cancelar</button>
                        <button id="toggleChartButton" onclick="toggleChart()" class="btn btn-info">Mostrar/ocultar gráfico</button>
                    </div>
                </form>
            </div>
            <div class="col-md-6">
                <h1 class="text-center blanco-text">LISTADO DE ASIGNATURAS</h1>
                <table class="table" id="tbl_asig">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>NOMBRE DE LA ASIGNATURA</th>
                            <th>CREDITOS</th>
                            <th>FECHA DE INICIO</th>
                            <th>FECHA DE FINALIZACION</th>
                            <th>PROFESOR</th>
                            <th>SILABO</th>
                            <th>METODO DE LA EVALUCION</th>
                            <th>RECURSOS</th>
                            <th>NIVEL</th>
                            <th>ACCIONES</th>
                        </tr>
                    </thead>
                    <TBody>
                        {% for asignatura in asignaturas %}
                            <tr>
                                <td>{{ asignatura.idAsignaturaBAFA }}</td>
                                <td>{{ asignatura.nombreAsignaturaBAFA }}</td>
                                <td>{{ asignatura.creditosAsignaturaBAFA }}</td>
                                <td>{{ asignatura.fechaInicioAsignaturaBAFA }}</td>
                                <td>{{ asignatura.fechaFinalizacionAsignaturaBAFA }}</td>
                                <td>{{ asignatura.profesorAsignaturaBAFA }}</td>
                                <td>
                                    {% if asignatura.silaboAsignaturaBAFA %}
                                    <a href="{{ asignatura.silaboAsignaturaBAFA.url }}" target="_blank">Ver PDF</a>
                                    {% else %}
                                    <b>N/A</b>
                                    {% endif %}
                                </td>
                                <td>{{ asignatura.metodoEvaluacionBAFA }}</td>
                                <td>{{ asignatura.recursosDidacticosBAFA }}</td>
                                <td>{{ asignatura.curso.nivelCursoBAFA }}</td>
                                <td>
                                    <a href="/editarAsignatura/{{ asignatura.idAsignaturaBAFA }}" class="btn btn-warning">Editar</a>
                                    <a href="javascript:void(0)" class="btn btn-danger" onclick="eliminarAsigantura('/eliminarAsigantura/{{ asignatura.idAsignaturaBAFA }}');">Borrar</a>
                                </td>
                            </tr>
                        {% endfor %}
                    </TBody>
                </table>
            </div>
        </div>
    </div>

    <script type="text/javascript">
        function eliminarAsigantura(url) {
            iziToast.question({
                timeout: 15000,
                close: true,
                overlay: true,
                displayMode: 'once',
                id: 'question',
                zindex: 999,
                title: 'CONFIRMACIÓN',
                message: '¿Está seguro de eliminar la Asignatura seleccionada?',
                position: 'center',
                buttons: [
                    ['<button><b>SI</b></button>', function (instance, toast) {
                        instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                        window.location.href = url;
                    }, true],
                    ['<button>NO</button>', function (instance, toast) {
                        instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                    }],
                ]
            });
        }
    </script>

    <script type="text/javascript">
        $("#frm_nueva_asig").validate({
            rules:{
                "id_curso": {
                    required: true
                },
                "nombreAsignaturaBAFA":{
                    required: true
                },
                "creditosAsignaturaBAFA":{
                    required: true
                },
                "fechaInicioAsignaturaBAFA":{
                    required: true
                },
                "fechaFinalizacionAsignaturaBAFA":{
                    required: true
                },
                "profesorAsignaturaBAFA":{
                    required: true
                },
                "silaboAsignaturaBAFA":{
                    required: true
                },
                "metodoEvaluacionBAFA":{
                    required: true
                },
                "recursosDidacticosBAFA":{
                    required: true
                }
            },
            messages:{
                "id_curso":{
                    required: "Por favor Seleccione un nivel"
                },
                "nombreAsignaturaBAFA":{
                    required: "Debe ingresar un nombre de la Asignatura"
                },
                "creditosAsignaturaBAFA":{
                    required: "Debe ingresar los creditos necesarios "
                },
                "fechaInicioAsignaturaBAFA":{
                    required: "Debe ingresar una fecha valida"
                },
                "fechaFinalizacionAsignaturaBAFA": {
                    required: "Por favor ingrese una fecha válida"
                },
                "profesorAsignaturaBAFA":{
                    required: "Debe ingresar un Profesor de la Asignatura"
                },
                "silaboAsignaturaBAFA":{
                    required: "Debe ingresar un PDF del silabo"
                },
                "metodoEvaluacionBAFA":{
                    required: "Debe ingresar un metodo de evaluacion"
                },
                "recursosDidacticosBAFA":{
                    required: "Debe ingresar recursos didacticos"
                }
            }
        });
    </script>

    <script type="text/javascript">
           //let table = new DataTable('#tbl_clientes');
           $(document).ready(function() {
               $('#tbl_asig').DataTable({
                   dom: 'Bfrtip',
                   language: {
                     url: '//cdn.datatables.net/plug-ins/1.13.7/i18n/es-ES.json',
                   },
                   buttons: [
                       {
                           extend: 'pdfHtml5',
                           text: '<i class="fa fa-file-pdf-o"></i> PDF',
                           titleAttr: 'Exportar a PDF',
                           className: 'btn btn-danger', // Clase de estilo para el botón
                           title: 'LISTADO DE LAS ASIGNATURAS'
                       },
                       {
                           extend: 'print',
                           text: '<i class="fa fa-print"></i> Imprimir',
                           titleAttr: 'Imprimir',
                           className: 'btn btn-primary' // Clase de estilo para el botón
                       },
                       {
                           extend: 'csv',
                           text: '<i class="fa fa-file-text-o"></i> CSV',
                           titleAttr: 'Exportar a CSV',
                           className: 'btn btn-success' // Clase de estilo para el botón
                       }
                   ]
               });
           });
          </script>
          <script>
              $(document).ready(function () {
                  $('.selectpicker').selectpicker();
              });
          </script>

          <script>
                  $(document).ready(function () {
                      $("#profesorPrincipalBAFA").fileinput({
                        //showUpload:false
                        //showRemove: false,
                        language:'es',
                      });
                  });
          </script>


                <div id="chartContainer" style="width: 50%; margin: auto; border: 2px solid black; padding: 10px; display: none;">
                  <canvas id="myChart"></canvas>
                </div>

                <script>
                    document.addEventListener('DOMContentLoaded', function () {
                      const ctx = document.getElementById('myChart');

                      const cursosSet = new Set();

                      const asignaturasCurso = {};
                      {% for asignatura in asignaturas %}
                        cursosSet.add("{{ asignatura.curso.nivelCursoBAFA }}");
                        if (!asignaturasCurso["{{ asignatura.curso.nivelCursoBAFA }}"]) {
                          asignaturasCurso["{{ asignatura.curso.nivelCursoBAFA }}"] = 1;
                        } else {
                          asignaturasCurso["{{ asignatura.curso.nivelCursoBAFA }}"] += 1;
                        }
                      {% endfor %}
                      const cursosArray = Array.from(cursosSet);
                      const posiciones = cursosArray.map((curso, index) => ({ x: index, y: asignaturasCurso[curso] || 0 }));

                      new Chart(ctx, {
                        type: 'bar',
                        data: {
                          labels: cursosArray,
                          datasets: [{
                            label: 'Cantidad de Niveles',
                            data: posiciones.map(posicion => posicion.y),
                            backgroundColor: 'rgba(248, 68, 68)',
                            borderColor: 'rgba(248, 68, 68)',
                            borderWidth: 1,
                          }]
                        },
                        options: {
                          scales: {
                            x: {
                              type: 'category',
                              position: 'bottom',
                            },
                            y: {
                              beginAtZero: true,
                              max: 10,
                              stepSize: 1,
                            }
                          }
                        }
                      });
                      window.toggleChart = function() {
                        const chartContainer = document.getElementById('chartContainer');

                        if (chartContainer.style.display === 'none') {
                          chartContainer.style.display = 'block';
                        } else {
                          chartContainer.style.display = 'none';
                        }
                      };
                    });

                </script>
{% endblock %}
